=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.mouse.js'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.mouse.js	2021-10-08 19:29:40 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.mouse.js	2022-03-06 21:49:25 +0000
@@ -2,7 +2,7 @@
 ** Module   : p2j.mouse.js
 ** Abstract : web-specific mouse management
 **
-** Copyright (c) 2015-2021, Golden Code Development Corporation.
+** Copyright (c) 2015-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ------------------------------Description----------------------------------
 ** 001 CA  20150826 First version.
@@ -49,10 +49,14 @@
 ** 020 HC  20210720 Fixed multiple mouse pointer issues (cursor not changing when it
 **                  should or changing when it should not).
 **     SBI 20210914 Reused the common code by creating new method p2j.screen.activateWindow.
-**     EVL 20211004 Optomization for widnow resize drag handler to fix secondary window processing.
+**     EVL 20211004 Optimization for widnow resize drag handler to fix secondary window processing.
 **     SBI 20211008 Renamed p2j.createDialog to p2j.createClipboardDialog and p2j.closeDialog to
 **                  p2j.closeClipboardDialog.
-
+**     VVT 20220306 1) Event listeners removed for "mouseenter" and "mouseleave": they were duplicating
+**                  "mouseout" and "mouseover" listeners in wrong order and resulted in duplicate events sent
+**                  to Java.  2) Function inlined: sendMouseExit, sendMouseEnter 3) sendMouseEvent renamed to
+**                  sendMouseOrOSEvent, Javadocs fixed 4) processMouseMove simplified and fixed: See #6013-94
+**                  for the description.
 */
 
 /*
@@ -133,10 +137,8 @@
    
    // mouse move: if the mouse cursor hasn't exited the last hovered area, cancel
    win.canvas.addEventListener("mousemove",  processMouseMove(this, "mousemove"));
-   win.canvas.addEventListener("mouseenter", processMouseMove(this, "mouseenter"));
-   win.canvas.addEventListener("mouseleave", processMouseMove(this, "mouseleave"));
-   win.canvas.addEventListener("mouseout",   processMouseMove(this, "mouseout"));
    win.canvas.addEventListener("mouseover",  processMouseMove(this, "mouseover"));
+   win.canvas.addEventListener("mouseout", processMouseMove(this, "mouseleave"));
 
    /**
     * Registers event handler for the supplied driver widget.
@@ -226,54 +228,19 @@
    }
    
    /**
-    * Send mouse leave event to a widget
-    * 
-    *  @param wid 
-    *         widget Id
-    *  @param evt
-    *         source mouse event
-    */
-   function sendMouseExit(wid, evt)
-   {
-      if (wid != undefined)
-      {
-         sendMouseEvent(wid, evt, "mouseleave", "mouseExit");
-      }
-   };
-
-   /**
-    * Send mouse leave enter to a widget
-    * 
-    *  @param wid 
-    *         widget Id
-    *  @param evt
-    *         source mouse event
-    */
-   function sendMouseEnter(wid, evt)
-   {
-      if (wid != undefined)
-      {
-         sendMouseEvent(wid, evt, "mouseenter", "mouseEnter");
-      }
-   };
-
-   /**
-    * Send mouse leave to a widget
-    * 
-    *  @param wid 
-    *         widget Id
-    *  @param evt
-    *         source mouse event
+    * Send mouse event to a widget
+    * 
+    *  @param wid 
+    *         widget Id
+    *  @param evt
+    *         mouse event source
     *  @param mouseOp
     *         operation name
     *  @param handler
-    *         the name of the handler method
+    *         the name of the OS event handler method
     */
-   function sendMouseEvent(wid, evt, mouseOp, handler)
+   function sendMouseOrOSEvent(wid, evt, mouseOp, handler)
    {
-      // send an exit event to last widget
-      var exitOpCode = p2j.screen.mouseOps[mouseOp] & 0xff;
-      
       var osEvent = p2j.screen.getOsEvent(evt, 
                                           win, 
                                           mouseOp, 
@@ -285,27 +252,28 @@
       }
       else
       {
-         win.sendExplicitMouseEvent(
-               wid, 
+         win.sendMouseEvent(
                evt, 
                win.getMousePos(evt), 
                win, 
-               exitOpCode);
+               p2j.screen.mouseOps[mouseOp] & 0xff,
+               wid);
       }
    };
 
    /**
-    * Listen for mouse move events.   This listener is intended to discard any mouse movement
+    * Listen for mouse "mousemove", "mouseout" and "mouseover"
+    * events. This listener is intended to discard any mouse movement
     * inside the same widget.
     *
     * TODO: CA: test how it interacts with drag (i.e. in EDITOR).
     *
     * @param    {Object} mThis
     *           The <code>MouseHandler</code> instance.
-    * @param    {String} mop
+    * @param    {String} mouseOp
     *           The mouse event associated with this callback.
     */
-   function processMouseMove(mThis, mop)
+   function processMouseMove(mThis, mouseOp)
    {
       return function(evt)
       {
@@ -314,64 +282,50 @@
             return;
          }
 
-         var mouseOp = mop;
-
-         var merged = mouseOp == "mouseenter" ? [win.mouseAwareWidgets["mouseenter"]]
-                                              : [win.mouseAwareWidgets[mouseOp], win.mouseAwareWidgets["mouseenter"]];
-         var wid = win.findMouseSource(evt, merged);
-         var enterWid = undefined;
          var mousePos = mThis.getMousePos(evt);
-         
-         // intercept early events and send them to MsgBlaster. Use "mouseenter" list as the
-         // events will be filtered and sent to MsgBlasterPeer only the minimum required
-         p2j.screen.checkMessageBlasterEvent(
-                  win.findMouseSource(evt, win.mouseAwareWidgets["mouseenter"]), mousePos, evt, mop);
-         
-         if ((mouseOp == "mousemove" || mouseOp == "mouseover")) 
-         {
-            enterWid = win.findMouseSource(evt, win.mouseAwareWidgets["mouseenter"]);
-            if (enterWid != undefined && wid != lastMouseWidget)
-            {
-               mouseOp = "mouseenter";
-            }
-         }
-
-         var opCode = p2j.screen.mouseOps[mouseOp] & 0xff;
-
-         // determine if the widget has changed
-         if (lastMouseWidget != undefined && lastMouseWidget == wid)
-         {
-            // if the widget has not changed but has a "mousemove" op, then let it process
-            // on the server-side
-            if (mouseOp == "mousemove" || mouseOp == "mouseover")
-            {
-               return;
-            }
-            
-            // otherwise, if widget has not changed, do nothing
+          
+         var newMouseSource
+          
+         if (mouseOp == "mousemove")
+         {
+            var mouseMoveAwareWidgets = win.mouseAwareWidgets["mousemove"]
+            if (mouseMoveAwareWidgets != null)
+            {
+                // intercept early mouse move events and send them to MsgBlaster.
+                p2j.screen.checkMessageBlasterEvent(mouseMoveAwareWidgets, mousePos, evt);
+                
+                newMouseSource = win.findMouseSource(evt, mouseMoveAwareWidgets)
+            }
          }
          else
          {
-            if (mouseOp == "mouseenter")
-            {
-               // send an enter event to the previous widget
-               sendMouseExit(lastMouseWidget, evt);
-               // send an enter event to this widget
-               sendMouseEnter(enterWid, evt);
-            }
-            else if (mouseOp == "mouseleave" || mouseOp == "mouseout")
-            {
-               // exiting the window
-               sendMouseExit(lastMouseWidget, evt);
-            }
-            else if (mouseOp == "mousemove" || mouseOp == "mouseover")
-            {
-               win.sendMouseEvent(evt, mousePos, win, opCode, wid);
-            }
-         }
-
-         // save the last widget the mouse was over
-         lastMouseWidget = wid;
+            // "mouseover" or "mouseout"
+            // we do not need to test widget for "mouseexit" here, since to be "mouseexit" aware,
+            // a widget should be "mouseenter" also aware
+            newMouseSource = win.findMouseSource(evt, win.mouseAwareWidgets["mouseenter"])
+         }
+         
+         if (lastMouseWidget != newMouseSource)
+         {
+            if (lastMouseWidget != undefined)
+            {
+               sendMouseOrOSEvent(lastMouseWidget, evt, "mouseleave", "mouseExit");
+            }
+
+            if (newMouseSource != undefined)
+            {
+               sendMouseOrOSEvent(newMouseSource, evt, "mouseenter", "mouseEnter");
+            }
+
+            lastMouseWidget = newMouseSource;
+         }
+         
+         if (mouseOp == "mousemove")
+         {
+             var opCode = p2j.screen.mouseOps[mouseOp] & 0xff;
+             // FIXME: this way of event sending ignores OS events, is this correct?
+             win.sendMouseEvent(evt, mousePos, win, opCode, newMouseSource);
+         }
 
          evt.preventDefault();
       };
@@ -402,12 +356,12 @@
    }
    
    // dragging operations
+   document.addEventListener("mousedown",   processMouseDragStart("mousedown"));
+   document.addEventListener("mousemove",   processMouseDrag     ("mousemove"));
    document.addEventListener("click",       processMouseDragStop ("click"));
    document.addEventListener("contextmenu", processMouseDragStop ("contextmenu"));
    document.addEventListener("dblclick",    processMouseDragStop ("dblclick"));
-   document.addEventListener("mousedown",   processMouseDragStart("mousedown"));
    document.addEventListener("mouseup",     processMouseDragStop ("mouseup"));
-   document.addEventListener("mousemove",   processMouseDrag     ("mousemove"));
    
    /**
     * Resizes the peer canvas according to given area.
@@ -898,12 +852,8 @@
       }
       
       var exitOpCode = p2j.screen.mouseOps["mouseleave"] & 0xff;
-      win.sendExplicitMouseEvent(wid, 
-            evt, 
-            win.getMousePos(evt), 
-            win, 
-            exitOpCode);
-//      console.log("mouseExit(%s); parent: %s", wid, pid);
+      // console.debug("mouseExit(%s); parent: %s", wid, pid);
+      win.sendMouseEvent(evt, win.getMousePos(evt), win, exitOpCode, wid);
       evt.preventDefault();
    };
 
@@ -913,14 +863,9 @@
       win.setHovered(this);
       
       p2j.screen.setActiveHoverWindow(win);
-//      console.log("mouseEnter(%s:%s): %s; %s", win.id, wid, this.ptr, this.forceDefault);
       win.setCursorStyle(this.effectivePtr(), this.wid == p2j.screen.getActiveDropDown());
-      var exitOpCode = p2j.screen.mouseOps["mouseenter"] & 0xff;
-      win.sendExplicitMouseEvent(wid, 
-            evt, 
-            win.getMousePos(evt), 
-            win, 
-            exitOpCode);
+      // console.debug("mouseEnter(%s:%s): %s; %s", win.id, wid, this.ptr, this.forceDefault);
+      win.sendMouseEvent(evt, win.getMousePos(evt), win, p2j.screen.mouseOps["mouseenter"] & 0xff, wid);
       evt.preventDefault();
    };
 
@@ -1000,11 +945,13 @@
    // c. mouse up: disables the drag
    var targets = [win, win, win, win, win, win.canvas.ownerDocument, win.canvas.ownerDocument];
    var mops = ["click", "contextmenu", "dblclick", "mousedown", "mouseup", "mousemove", "mouseleave"];
-   var listeners = [processMouseDragStop (this, "click"), processMouseDragStop (this, "contextmenu"),
-                    processMouseDragStop (this, "dblclick"), processMouseDragStart(this, "mousedown"),
-                    processMouseDragStop (this, "mouseup"), processMouseDrag     (this, "mousemove"),
+   var listeners = [processMouseDragStop (this, "click"),
+                    processMouseDragStop (this, "contextmenu"),
+                    processMouseDragStop (this, "dblclick"),
+                    processMouseDragStart(this, "mousedown"),
+                    processMouseDragStop (this, "mouseup"),
+                    processMouseDrag     (this, "mousemove"),
                     processMouseDragStop (this, "mouseleave")];
-   // win.canvas.addEventListener("drag", processMouseDrag(this, "drag"));
    addListeners(targets, mops, listeners);
    
    this.deregisterListeners = function()

=== modified file 'src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js'
--- src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js	2022-02-25 14:46:27 +0000
+++ src/com/goldencode/p2j/ui/client/gui/driver/web/res/p2j.screen.js	2022-03-06 21:49:25 +0000
@@ -148,6 +148,13 @@
 **                  need to be completed).
 **     SBI 20220223 Added "filters" parameter to chooseFiles. Changed to select a unique child of input of file type
 **                  for Uploader dom node.
+**     VVT 20220306 1) The mouseButtonDownStack variable added to keep last mouse button pressed/released
+**                  state stack.  2) evt.preventSendToApplication is no more used to prevent some event
+**                  handlers. evt.preventDefault() is used instead.  3) event listeners are now not registered
+**                  for "mouseenter", "mouseleave", "mouseover" and "mouselout" events.  4) trivial
+**                  sendExplicitMouseEvent function inlined.  5) sendMouseEvent: a correct button field of
+**                  output event is now calculated for *all* events (not only press/release/click events).  6)
+**                  getModifiersBitMask inlined 7) checkMessageBlasterEvent: unused mop argument removed.
 */
 
 /*
@@ -420,6 +427,16 @@
    var totalFilesLimit = 100 * 1024 * 1024;
    
    /**
+    * Last mouse button pressed/released state stack.
+    *
+    * The value is used to get the 'button' value to pass along with events, for which the value is not
+    * reliable directly provided by browsers.
+    *
+    * The value is computed based on mouse down/up event data (fields 'buttons' and 'button').
+    */
+   var mouseButtonDownStack = [];
+    
+   /**
     * Dispatch mouse events to the registered widgets. 
     */
    function MouseEventDispatcher()
@@ -573,7 +590,7 @@
       };
 
       /**
-       * Handles a document widen "mousedown" event.
+       * Handles a document-wide "mousedown" event.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -613,7 +630,7 @@
       }
       
       /**
-       * Handles a document widen "mouseup" event.
+       * Handles a document-wide "mouseup" event.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -651,7 +668,7 @@
       }
 
       /**
-       * Handles a document widen "click" event.
+       * Handles a document-wide "click" event.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -675,7 +692,7 @@
       }
 
       /**
-       * Handles a document widen "contextmenu" event. Forces contextmenu to be postponed until
+       * Handles a document-wide "contextmenu" event. Forces contextmenu to be postponed until
        * mouseup is not raised.
        * 
        * @param    {Event} evt
@@ -705,7 +722,7 @@
       }
 
       /**
-       * Handles a document widen "mousemove" event and dispatches artificial "drag" events.
+       * Handles a document-wide "mousemove" event and dispatches artificial "drag" events.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -748,25 +765,21 @@
             var dx = Math.abs(mouseEventDispatcher.mouseDownEvent.x - evt.x);
             var dy = Math.abs(mouseEventDispatcher.mouseDownEvent.y - evt.y);
             
-            // only start dragging when the distance since mouse down is equal or greater 8 pixels
+            // only start dragging when mouse was moved 8 or more pixels from the mouse down point
             dragging = dx >= 8 || dy >= 8;
-            if(dragging)
-            {
-               //console.log("mouseMoveHandler: drag ON: " + evt.x + " " + evt.y);
-            }
          }
 
          if(dragging)
          {
             //console.log("mouseMoveHandler: dispatch drag event: " + evt.x + " " + evt.y);
             dispatchEvent("drag", evt);
+            // Disable MOVE event generation is other mouse event handlers
+            evt.preventDefault();
          }
-
-         evt.preventSendToApplication = true;
       }
       
       /**
-       * Handles a document widen "dragover" event.
+       * Handles a document-wide "dragover" event.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -782,7 +795,7 @@
       }
       
       /**
-       * Handles a document widen "drop" event.
+       * Handles a document-wide "drop" event.
        * 
        * @param    {Event} evt
        *           The raised mouse event.
@@ -1587,8 +1600,13 @@
          {
             // cannot use an array here because some indexes are negative numbers
             this.mouseAwareWidgets[mouseOp] = {};
+            // FIXME: replace the expression by switch 
             if (mouseOp !== "drag" && mouseOp !== "click" && mouseOp !== "dblclick" && 
-                mouseOp !== "mouseup" && mouseOp !== "mousedown" && mouseOp !== "contextmenu")
+                mouseOp !== "mouseup" && mouseOp !== "mousedown" && mouseOp !== "contextmenu"
+                // These enter/leave are generated by mousemove, we do not need these events
+                && mouseOp !== "mouseenter" && mouseOp !== "mouseleave"
+                && mouseOp !== "mouseover" && mouseOp !== "mouselout"
+               )
             {
                this.canvas.addEventListener(mouseOp, this.raiseMouseEvent(this, mouseOp));
             }
@@ -1909,11 +1927,6 @@
       
       return function(evt)
       {
-         if(evt.preventSendToApplication)
-         {
-            return;
-         }
-         
          var mousePos = wThis.getMousePos(evt);
 
          if (!me.canProcessOsEvent(evt, wThis))
@@ -3425,11 +3438,6 @@
       return this.drawCache[md5];
    }
 
-   Window.prototype.sendExplicitMouseEvent = function(wid, evt, mousePos, wThis, opCode)
-   {
-      this.sendMouseEvent(evt, mousePos, wThis, opCode, wid);
-   }
-   
    /**
     * Send a mouse event to be processed by the Java side.
     *
@@ -3441,18 +3449,77 @@
     *          The window reference.
     * @param   {Number} opCode
     *          The ID of this mouse event.
+    * @param   {Number} wid
+    *          Widget ID
     */
    Window.prototype.sendMouseEvent = function(evt, mousePos, wThis, opCode, wid)
    {
-      var mouseEvent = {
-                           windowId   : wThis.id,
-                           opCode     : opCode,
-                           wid        : wid,
-                           x          : mousePos.x,
-                           y          : mousePos.y,
-                           button     : evt.which,
-                           clicks     : evt.detail
+      const mouseEvent = {
+                          windowId   : wThis.id,
+                          opCode     : opCode,
+                          wid        : wid,
+                          x          : mousePos.x,
+                          y          : mousePos.y,
+                          clicks     : evt.detail
                         };
+
+      // Set the output event button field:
+      // 
+      // For mouse press/release/click browser provides correct button values, so we get it from event and
+      // store in a field.
+      //
+      // In all other cases the browser does not provide a value, so we compute the value based on the
+      // previous button press stack.
+
+      const button = evt.button;
+
+      switch (opCode) {
+      case 4:   // mousedown
+      case 10:  // mouseup
+          // Collect all currently pressed mouse buttons to a set to facilitate further access.
+          const buttons = evt.buttons;
+          const buttonsDown = new Set();
+          for (let i = 0, mask = 1; i < 10; i++, mask <<= 1)
+          {
+             if (buttons & mask)
+             {
+                 // Note: button numeration in 'buttons' and 'button' is slightly different.
+                 buttonsDown.add(i == 1 ? 2 : i == 2 ? 1 : i);
+             }
+          }
+          
+          // Sync the stack with actual buttons (our button press info may be incorrect if the user managed to
+          // press or release buttons outside the workspace area) and remove this event button from the stack.
+          const stack = mouseButtonDownStack.filter(function(e) { return e !== button && buttonsDown.has(e) })
+          if (opCode == 4)
+          {
+              stack.push(button);
+          }
+          
+          // console.debug("mousedown/mouseup: opCode: " + opCode
+          //               + " evt.buttons: " + evt.buttons
+          //               + " evt.button: " + evt.button
+          //               + " stack before: " + mouseButtonDownStack
+          //               + " stack after: " + stack
+          //              );
+          mouseButtonDownStack = stack;
+          mouseEvent.button = button + 1;
+          break;
+      case 1:   // mouseclick
+          mouseEvent.button = button + 1;
+          break;
+      default: // events other than press/release/click
+          const len = mouseButtonDownStack.length;
+          mouseEvent.button = len > 0 ? (mouseButtonDownStack[len - 1] + 1) : 0;
+      }
+
+      console.debug("sendMouseEvent: opCode: " + opCode
+                    + " evt.buttons: " + evt.buttons
+                    + " evt.button: " + evt.button
+                    + " mouseEvent.button: " + mouseEvent.button
+                    + " stack: " + mouseButtonDownStack
+                    + " wid: " + wid
+                   );
       
       // fix mouse click count
       if (p2j.isIe && (opCode == mouseOps["click"]) && (evt.detail == 0))
@@ -3460,7 +3527,28 @@
          mouseEvent.clicks = 1;
       }
       
-      mouseEvent.bitmask = getModifiersBitMask(evt);
+      // Get modifiers: The keys modifier mask that represents which
+      // of the modifier keys are down. If 0, 1, 2, or 3-bit is set,
+      // then respectivelly the shift, the ctrl, the meta or the alt
+      // key is pressed.
+      var modifiers = 0;
+      if (evt.shiftKey !== undefined && evt.shiftKey)
+      {
+         modifiers |= 1;
+      }
+      if (evt.ctrlKey !== undefined && evt.ctrlKey)
+      {
+         modifiers |= 2;
+      }
+      if (evt.metaKey !== undefined && evt.metaKey)
+      {
+         modifiers |= 4;
+      }
+      if (evt.altKey !== undefined && evt.altKey)
+      {
+         modifiers |= 8;
+      }
+       mouseEvent.bitmask = modifiers;
       
       var wheelEvent = (evt.deltaMode !== undefined);
       
@@ -3471,8 +3559,9 @@
          mouseEvent.rotation = getScrollAmountDelta(evt);
          mouseEvent.unit     = getScrollAmountUnit(evt);
       }
-      //console.debug("sendMouseEvent " + JSON.stringify(mouseEvent));
-      //console.debug("event name: " + getMouseEventName(mouseEvent));
+
+      // console.debug("sendMouseEvent: " + JSON.stringify(mouseEvent));
+      // console.debug("event name: " + getMouseEventName(mouseEvent));
       // send the mouse event
       p2j.socket.sendMouseEvent(mouseEvent);
       
@@ -3482,40 +3571,6 @@
    }
    
    /**
-    * Returns the bit mask that represents the current modifier keys are pressed during this
-    * mouse event occurred.
-    * 
-    * @param    {Event} evt
-    *           The mouse event.
-    * 
-    * @return   The keys modifier mask that represents which of the modifier keys are down.
-    *           If 0, 1, 2, or 3-bit is set, then respectivelly the shift, the ctrl, the meta or
-    *           the alt key is pressed.
-    */
-   function getModifiersBitMask(evt)
-   {
-      var modifiers = 0;
-      if (evt.shiftKey !== undefined && evt.shiftKey)
-      {
-         modifiers |= 1;
-      }
-      if (evt.ctrlKey !== undefined && evt.ctrlKey)
-      {
-         modifiers |= 2;
-      }
-      if (evt.metaKey !== undefined && evt.metaKey)
-      {
-         modifiers |= 4;
-      }
-      if (evt.altKey !== undefined && evt.altKey)
-      {
-         modifiers |= 8;
-      }
-      
-      return modifiers;
-   }
-   
-   /**
     * Gets the mouse event name for the given event. It has a debug purpose only.
     * 
     * @param    evt
@@ -5793,18 +5848,18 @@
    var WM_MOUSEMOVE = 512;
    
    /**
-    * Handles mouse move on the screen and preserves the last event.
+    * If the widget with ID provided as argument is registered with MessageBlaster, send WM_MOUSEMOVE
+    * event to the widget.
     *
+    * @param   wid
+    *          A valid widget ID
+    * @param   mousePos
+    *          Mouse position
     * @param   evt
     *          The mouse move event.
     */
-   me.checkMessageBlasterEvent = function(wid, mousePos, evt, mop)
+   me.checkMessageBlasterEvent = function(wid, mousePos, evt)
    {
-      if (wid == null)
-      {
-         return;
-      }
-      
       // low-level os notifications
       var winId = me.wgListMB.get(wid);
       if (winId != null)

=== modified file 'src/com/goldencode/p2j/ui/client/widget/AbstractContainer.java'
--- src/com/goldencode/p2j/ui/client/widget/AbstractContainer.java	2022-03-11 20:58:47 +0000
+++ src/com/goldencode/p2j/ui/client/widget/AbstractContainer.java	2022-03-13 18:37:02 +0000
@@ -122,6 +122,7 @@
 **     ME  20211209 Fixed focus lost issue when current focus is the last entry (direct) or first (reverse). 
 **     AL2 20220127 Added representation for all selected widgets in this container.
 **     VVT 20220218 Missing @Override annotations added.
+**     VVT 20220306 findMouseSource(eventID, NativePoint) method is overriden.
 **     EVL 20220311 Fix for invalid initial current focus for non-modal windows.
 */
 
@@ -2294,6 +2295,76 @@
    }
    
    /**
+    * Find the source for mouse event.
+    * 
+    * @param eventId
+    *        the event ID to match 
+    * @param p
+    *        the mouse position relative to this widget
+    *        
+    * @return the mouse event source or {@code null} if no source found.
+    */
+   @Override
+   public Widget<O> findMouseSource(int eventId, NativePoint p)
+   {
+      // If this widget is not visible or not enabled return null
+      if (!isVisible() || !isEnabled())
+      {
+         return null;
+      }
+      
+      // offset insets if any
+      Insets insets = insets();
+      NativePoint pbody; 
+      if (insets != null && insets != Insets.ZERO_INSETS)
+      {
+         NativeInsets ninsets = screen().coordinates().insetsToNative(insets);
+         pbody = p.offset(-ninsets.left, -ninsets.top);
+      }
+      else
+      {
+         pbody = p;
+      }
+
+      List<Widget<O>> widgets = widgetsAsList(true);
+      
+      // to allow z-order awareness, process the widgets in reverse order: the top-most widgets
+      // are always last in the widget list
+      int maxIndex = widgets.size() - 1;
+      for (int i = maxIndex; i >= 0; i--)
+      {
+         Widget<O> w = widgets.get(i);
+         if (!w.isVisible()
+             || !w.isEnabled()
+             || !w.physicalBounds().contains(p))
+         {
+            continue;
+         }
+
+         Widget<O> found = w.findMouseSource(eventId, pbody.minus(w.physicalLocation()));
+         if (found != null)
+         {
+            return found;
+         }
+         
+         // FIXME vvt check how rewrite the following properly
+         
+         // MENUBAR can allocate more place than just MENUBAR string itself.
+         // If some frame is allocated in the window right under the MENUBAR,
+         // than we should properly search mouse event in the controversial area.
+         // MENUBAR string and frame cannot intersects, so the algorithm will be the following:
+         // MENUBAR will be searched earlier than frames and if it will not find the source child
+         // owning the event, than we should search the frames.
+         //         if (w instanceof Menu && !((Menu<?>)w).config().popupOnly)
+         //         {
+         //            continue;
+         //         }
+      }
+
+      return super.findMouseSource(eventId, p);
+   }
+
+   /**
     * Helper method for traversing widgets in the container.
     *
     * @param   iter

=== modified file 'src/com/goldencode/p2j/ui/client/widget/TitledWindow.java'
--- src/com/goldencode/p2j/ui/client/widget/TitledWindow.java	2022-02-15 12:19:45 +0000
+++ src/com/goldencode/p2j/ui/client/widget/TitledWindow.java	2022-03-09 16:17:30 +0000
@@ -281,21 +281,6 @@
    }
 
    /**
-    * Find the widget to which the given mouse event can be applied.
-    * 
-    * @param    evt
-    *           The mouse event.
-    * 
-    * @return   A widget over which the mouse is positioned or {@code null} if none found.
-    *           By default, this method returns {@code null}.
-    */
-   public Widget<O> findMouseSource(MouseEvt evt)
-   {
-      // no-op by default
-      return null;
-   }
-   
-   /**
     * Process key event.
     * 
     * @param   event

=== modified file 'src/com/goldencode/p2j/ui/client/widget/Widget.java'
--- src/com/goldencode/p2j/ui/client/widget/Widget.java	2022-02-18 17:35:06 +0000
+++ src/com/goldencode/p2j/ui/client/widget/Widget.java	2022-03-06 21:49:25 +0000
@@ -99,6 +99,11 @@
 **     EVL 20210820 Adding methods to get initial widget width, height and whether to use initial values on
 **                  layout.
 **     VVT 20220218 Javadocs fixes.
+**     VVT 20220306 findMouseSource(eventID, NativePoint) method is overriden.
+**     VVT 20220306 new findMouseSource(w.findMouseSource(eventID, NativePoint)) method introduced instead
+**                  of obsolete findMouseSource(w.findMouseSource(eventID)) along with default
+**                  implementation.  This method returns 'this' iff widget is visible and enabled and mouse
+**                  event type matches mouse actions defined in this widget. Otherwise null is returned.
 */
 /*
 ** This program is free software: you can redistribute it and/or modify
@@ -1247,4 +1252,28 @@
    {
       return false;
    }
+
+   /**
+    * Find the source for mouse event.
+    * 
+    * @param eventId
+    *        the event ID to match 
+    * @param p
+    *        the mouse position relative to this widget
+    *        
+    * @return the mouse event source or {@code null} if no source found.
+    */
+   default Widget<O> findMouseSource(int eventId, NativePoint p)
+   {
+      // By default this method returns either this object or null.
+      // 
+      // This method returns 'this' iff all these conditions are true:
+      // 1. this widget is visible and enabled
+      // 2. mouse event type matches mouse actions defined in this widget
+      return (isVisible()
+               && isEnabled()
+               && getMouseActions().contains(eventId)) ? this : null;
+   }
+
+   
 }

